diebold.mariano.test <- function(x, alternative = c("two.sided", "less", "greater"), k) {

    if (NCOL(x) > 1)

        stop("x is not a vector or univariate time series")     
        if (any(is.na(x)))

        stop("NAs in x")
    alternative <- match.arg(alternative)    
    DNAME <- deparse(substitute(x))
    n <- NROW(x)
    cv <- acf(x, lag.max=k, type="covariance", plot=FALSE)$acf[,,1]     
    eps <- 1.0e-8
    vr <- max(eps, sum(c(cv[1], 2*cv[-1])) / n)     
    STATISTIC <- mean(x) / sqrt(vr)
    names(STATISTIC) <- "Standard Normal"     
    METHOD <- "Diebold-Mariano Test"
    if (alternative == "two.sided")

        PVAL <- 2 * pnorm(-abs(STATISTIC))     
        else if (alternative == "less")

        PVAL <- pnorm(STATISTIC)
    else if (alternative == "greater")

        PVAL <- pnorm(STATISTIC, lower.tail = FALSE)     
        PARAMETER <- k
    names(PARAMETER) <- "Truncation lag"     
    structure(list(statistic = STATISTIC, parameter = PARAMETER, alternative = alternative,
                   p.value = PVAL, method = METHOD, data.name = DNAME), class = "htest")
}


e1 <- rnorm(500)
e2 <- rnorm(500)

diebold.mariano.test(abs(e1)-abs(e2), k = 3)$p.value

e1 <- rnorm(500, sd=1)
e2 <- rnorm(500, sd=1.3)

diebold.mariano.test(g(e1)-g(e2), k = 3)


e<-matrix(NULL, 40,14);e.nit<-matrix(NULL,40,14)


dif_MSE<- function(dat=aAR,dat.nit=aAR.nit) {
  e<-matrix(mapply( function(i,j) {(dat[j,i][[1]]-realSample[j,i][[1]])^2} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))
  e.nit<-matrix(mapply( function(i,j) {(dat.nit[j,i][[1]]-realSample.nit[j,i][[1]])^2} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))
  
  for(j in (1:ncol(sinf) )) {
  for(i in (1:fwindow))  {
    eOrder<-na.omit(sapply(e[,j], function(x) x[i]))
    eOrder.nit<-na.omit(sapply(e.nit[,j], function(x) x[i]))
    res [ i,j ]<-diebold.mariano.test(eOrder-eOrder.nit, k = 3)$p.value
      }
      
  }
  colnames(res)<-include.countries
  res
}
  




res<-matrix(NA, 40,14);
for(j in (1:ncol(sinf) )) {
  for(i in (1:fwindow))  {
    e [[i]]<- unlist( list((  c(dat[i,j][[1]] ) - c(realSample[i,j][[1]] ))  ^2))
    e.nit[[i]]<-unlist((unlist(c(dat.nit[i,j][[1]]) - c(realSample.nit[i,j][[1]]))^2))
    
      }
      
}
res
}








get_diff <- function(dat=aAR){ ray=cbind(rep(1:ncol(sinf), each=fwindow), rep(1:fwindow,ncol(sinf)));
eSQR<-matrix(mapply( function(i,j) {(dat[j,i][[1]]-realSample[j,i][[1]])^2} ,i=ray[,1], j=ray[,2]), c(fwindow,fwindow,ncol(sinf)))
x<-matrix(NA,fwindow,ncol(sinf))

for (k in (1:ncol(sinf))) {
for (j in (1:fwindow) ) {
 # x[j,k]<-sum(eSQR[j,k][[1]]^2) / length(eSQR[j,k][[1]])
    tmpS<-na.omit(sapply(eSQR[,k], function(x) x[j]))
  x[j,k][[1]]<- tmpS
}
}
x
};










dif_MSE(dat, dat.nit, realsample1=realSample, realsample.nit=realSample.nit) {
  dif<-list(NA)
  
eSQR<-lapply(dat, function(x) { (x-realSample[[i]])^2} )
  
eSQR<-matrix(mapply( function(i,j) {(dat[j,i][[1]]-realSample[j,i][[1]])^2} ,  i=ray[,1], j=ray[,2]),
  c(fwindow,fwindow,ncol(sinf)))
eSQR.nit<-matrix(mapply( function(i,j) {(dat.nit[j,i][[1]]-realSample.nit[j,i][[1]])^2} , i=ray[,1], j=ray[,2]), 
  c(fwindow,fwindow,ncol(nit.sinf)))
  for(i in(1:NCOL(eSQR))) {
    for(j in(1:NROW(eSQR))) {
      diff[[i] = eSQR[[1]]-eSQR.nit[[1]]
      
  
  
}



