library("timeSeries")
library("forecast")
library("fMarkovSwitching")
library("tsDyn")
library("multicore")
library("doMC")
getDoParName()
options(cores=15)
registerDoMC()
getDoParWorkers()


infFile = "/media/148891B6889196B8/AR/min.RData"
load(infFile)
aicAR<-aicARMA_AR<-aicARMA_MA<-bicARMA_MA<-bicARMA_AR<-matrix(NA,ncol=40,nrow=14)
fwindow=40;
# apply(matrix(1:21),2,function(j) c(start(na.contiguous(inf[,j])), end(na.contiguous(inf[,j]))) )

nit.periods<-apply(as.matrix(c(1:21)), 1, function(i) {((span[i,5]-span[i,1])*12)-span[i,2]+1})

it.periods<-apply(as.matrix(c(1:21)), 1, function(i) {((span[i,3]-span[i,5])*12)+span[i,4]})
span$nit.periods<-nit.periods
span$it.periods<-it.periods

exclude.countries<-rownames(subset(span, (it.periods<100 | nit.periods<100) | is.na(target.adoption=="NA")))
include.countries<-rownames(subset(span, it.periods>100 & nit.periods>100))

sinf<-inf[,c(include.countries)]

span.inc<-subset(span, it.periods>100 & nit.periods>100)
nit.sinf<-it.sinf<- sinf;

for (j in (1:dim(sinf)[2] )) {
window(it.sinf[,j], end= c(span.inc[j,5]-1, 12))<-NA
window(nit.sinf[,j], start= c(span.inc[j,5], 1))<-NA
}

ray<-cbind(rep(1:dim(sinf)[2],each=fwindow),rep.int(1:fwindow,dim(sinf)[2]));

# AR forecast are stored in aAR matrix (40 x 14) consisting of vectors, whose dimensions range between 1 and 40.
aARsil<-matrix(mapply( frcst_AR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));

dimnames(aAR)<-list(1:fwindow,include.countries)

aARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=sinf,ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));

bAR<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=sinf,  max.q=0, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));
bicAR<-bicARMA_AR # AR icin orderlari topluyoruz.
bARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=sinf, max.q=12, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));


dimnames(aAR)<-dimnames(aARMA)<-dimnames(bARMA)<-list(1:40,include.countries)
save.image(file="/home/ege/Documents/ARMAres.rdata")

# 40 periyot ötedeki forecastlara ulasmak icin
apply(aAR,c(1,2), function(x) x[[1]][40])



# IT period

aAR<-matrix(mapply( frcst_AR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));

dimnames(aAR)<-list(1:fwindow,include.countries)

aARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf,ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));

bAR<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf,  max.q=0, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

bicAR<-bicARMA_AR # AR icin orderlari topluyoruz.

bARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, max.q=12, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));


dimnames(aAR)<-dimnames(aARMA)<-dimnames(bARMA)<-list(1:40,include.countries)
save.image(file="/home/ege/Documents/ARMAresIT.rdata")

# nonIT periyot

load(file="/home/ege/Documents/ARMAresIT.rdata");
aAR<-matrix(mapply( frcst_AR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));

dimnames(aAR)<-list(1:fwindow,include.countries)

aARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf,ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));

bAR<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf,  max.q=0, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

bicAR<-bicARMA_AR # AR icin orderlari topluyoruz.

bARMA<-matrix(mapply( frcst_ARMA ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, max.q=12, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));


dimnames(aAR)<-dimnames(aARMA)<-dimnames(bARMA)<-list(1:40,include.countries)
save.image(file="/home/ege/Documents/ARMAresNIT.rdata")


library("fMarkovSwitching")
library("tsDyn")
library("multicore")
library("doMC")
getDoParName()
options(cores=16)
registerDoMC()
getDoParWorkers()


b<-foreach(i=c(1:ncol(it.sinf))) %dopar% {
      cat(i);
      library("fMarkovSwitching")
      library("timeSeries")
      library("forecast")
      library("tsDyn")

      apply( matrix(c(1:1)),1,function (j) MarkovApply(dat=it.sinf, col.index= i,horizon=j,AR.lags=bicAR[i,]) )
      }

      MarkovApply<-function(dat, col.index,horizon,AR.lags=rep(1,40)) {
	      series <- head(na.contiguous(dat[,col.index]), -fwindow+horizon-1)
	      lags= max(AR.lags[horizon],1)
	      x<-na.contiguous(quantmod::Lag(c(series),k=c(0:lags) ) )
	      model<-MS_Regress_Fit(x[,1],x[,-1], S=rep(1,lags), k=2)
	      model
	      }


library("tsDyn")
library("quantmod")

load(file="/home/ege/Documents/ARMAresNIT.rdata")
aSETAR.nit<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bSETAR.nit<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf,ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

aNNETTS.nit<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, size=3, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bNNETTS.nit<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, size=3, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

aLSTAR.nit<-matrix(mapply( frcst_LSTAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));


load(file="/home/ege/Documents/ARMAresIT.rdata")
aSETAR<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bSETAR<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf,ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

aNNETTS<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, size=3, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bNNETTS<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, size=3, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

aLSTAR<-matrix(mapply( frcst_LSTAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

realSample<-matrix(mapply( frcst_real ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));


xtable::xtable(get_MSE(aAR), caption="aAR IT", display=rep("e",15))
xtable::xtable(get_MSE(bAR), caption="bAR IT", display=rep("e",15))

xtable::xtable(get_MSE(aARMA), caption="aARMA IT", display=rep("e",15))
xtable::xtable(get_MSE(bARMA), caption="bARMA IT", display=rep("e",15))

xtable::xtable(get_MSE(aSETAR), caption="aSETAR IT", display=rep("e",15))
xtable::xtable(get_MSE(bSETAR), caption="bSETAR IT", display=rep("e",15))

xtable::xtable(get_MSE(aNNETTS), caption="aNNETTS IT", display=rep("e",15))
xtable::xtable(get_MSE(bNNETTS), caption="bNNETTS IT", display=rep("e",15))


save.image(file="/home/ege/Documents/ARMAresNIT.rdata")

load(file="/home/ege/Documents/ARMAresIT.rdata");
aSETAR<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bSETAR<-matrix(mapply( frcst_SETAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf,ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

aLSTAR<-matrix(mapply( frcst_LSTAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bLSTAR<-matrix(mapply( frcst_LSTAR ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

fason<-bLSTAR
aNNETTS<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, size=3, ic="aic")), c(fwindow,fwindow,dim(sinf)[2]));
bNNETTS<-matrix(mapply( frcst_nnetts ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, size=3, ic="bic")), c(fwindow,fwindow,dim(sinf)[2]));

realSample<-matrix(mapply( frcst_real ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=it.sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));
realSample.nit<-matrix(mapply( frcst_real ,i=ray[,1], j=ray[,2], MoreArgs=list(dat=nit.sinf, order.max=12)), c(fwindow,fwindow,dim(sinf)[2]));


MSE_RW.it<- matrix(mapply( function (i,j) {mean((diff(tail(na.contiguous( it.sinf[,i]),fwindow+1 ),j))^2) } ,i=ray[,1], j=ray[,2] ),fwindow)
MSE_RW.nit<- matrix(mapply( function (i,j) {mean((diff(tail(na.contiguous( nit.sinf[,i]),fwindow+1 ),j))^2) } ,i=ray[,1], j=ray[,2] ),fwindow)


xtable::xtable(get_MSE(aAR), caption="aAR IT", display=rep("e",15))
xtable::xtable(get_MSE(bAR), caption="bAR IT", display=rep("e",15))

xtable::xtable(get_MSE(aARMA), caption="aARMA IT", display=rep("e",15))
xtable::xtable(get_MSE(bARMA), caption="bARMA IT", display=rep("e",15))

xtable::xtable(get_MSE(aSETAR), caption="aSETAR IT", display=rep("e",15))
xtable::xtable(get_MSE(bSETAR), caption="bSETAR IT", display=rep("e",15))

xtable::xtable(get_MSE(aNNETTS), caption="aNNETTS IT", display=rep("e",15))
xtable::xtable(get_MSE(bNNETTS), caption="bNNETTS IT", display=rep("e",15))


save.image(file="/home/ege/Documents/ARMAresIT.rdata")
