# requires span.inf,
setwd("/home/ege/Desktop/itNit")
load("DataOnly_forecast.rData")

library("timeSeries")
library("forecast")
library("fMarkovSwitching")
library("tsDyn")
library("multicore")
library("doMC")
require("forecast")

getDoParName()
options(cores=14)
registerDoMC()
cat( )
getDoParWorkers()

nit.periods<-apply(as.matrix(c(1:21)), 1, function(i) {((span[i,5]-span[i,1])*12)-span[i,2]+1})

it.periods<-apply(as.matrix(c(1:21)), 1, function(i) {((span[i,3]-span[i,5])*12)+span[i,4]})
span$nit.periods<-nit.periods
span$it.periods<-it.periods

exclude.countries<-rownames(subset(span, (it.periods<100 | nit.periods<100) | is.na(target.adoption=="NA")))
include.countries<-rownames(subset(span, it.periods>100 & nit.periods>100))
span.inc<-subset(span, it.periods>100 & nit.periods>100)

# sinf<-inf[,c(include.countries)]
sinf     <-ts( read.csv("sinfgretl_Temmuz4.csv")[ ,1+c(1:14)], frequency=12, start=c(1957,2) )
colnames(sinf)<- include.countries

sinfSAS  <-ts( read.csv("sinfgretl_Temmuz4.csv")[ ,-c(1:(14+1))], frequency=12, start=c(1957,2) )
colnames(sinfSAS)<- include.countries

nit.sinf<-it.sinf<- sinf;
nit.sinfSAS<-it.sinfSAS<- sinfSAS;



### constructing nit.sinf and it.sinf data from sinf##
for (i in c(1:nrow(span.inc) )) {
main<- window(sinf[,i], start=start(sinf), end= c(span.inc[i,5]-1,12) )
main<- c(  main, rep(NA, (nrow(sinf)-length(main))  )  )
nit.sinf[,i] <- main
}

for (i in c(1:nrow(span.inc) )) {
main<- window(sinf[,i], start=c(span.inc[i,5],1), end=end(sinf) )
main<- c( rep(NA, (nrow(sinf)-length(main))  ) , main )
it.sinf[,i] <- main
}

for (j in (1:dim(sinf)[2] )) {
window(it.sinf[,j], end= c(span.inc[j,5]-1, 12))<-NA
window(nit.sinf[,j], start= c(span.inc[j,5], 1))<-NA
}
############ end of constructing ### 



### constructing nit.sinfSAS and it.sinfSAS data from sinfSAS##
for (i in c(1:nrow(span.inc) )) {
main<- window(sinfSAS[,i], start=start(sinfSAS), end= c(span.inc[i,5]-1,12) )
main<- c(  main, rep(NA, (nrow(sinfSAS)-length(main))  )  )
nit.sinfSAS[,i] <- main
}

for (i in c(1:nrow(span.inc) )) {
main<- window(sinfSAS[,i], start=c(span.inc[i,5],1), end=end(sinfSAS) )
main<- c( rep(NA, (nrow(sinfSAS)-length(main))  ) , main )
it.sinfSAS[,i] <- main
}
rm(main)

for (j in (1:dim(sinf)[2] )) {
window(it.sinfSAS[,j], end= c(span.inc[j,5]-1, 12))<-NA
window(nit.sinfSAS[,j], start= c(span.inc[j,5], 1))<-NA
}
############ end of constructing SAS ### 





# getting the additive deseasonalizing values for 12 months variable  *  sinfAdj *
# sinfAdj is assumed to be subtracted from sinf 
sinfAdj <- window(sinf, start=c(2009,1), end=c(2009,12)) -window(sinfSAS, start=c(2009,1), end=c(2009,12))
colnames(sinfAdj)<-include.countries


## listing the data matrix
lsinf<-lapply(sinf,function(x) x) 
lit.sinf<-lapply(it.sinf,function(x) x) 
lnit.sinf<-lapply(nit.sinf,function(x) x)

### seasonal adjustment################3
